## Textadept Quick Reference Book

<script src="https://gumroad.com/js/gumroad.js"></script>

<div style="float: left; margin: 0 1em 0 1em;">
  <img src="images/quickref_small.png" alt="" style="border-width: 1px;"/>
</div>

*Textadept Quick Reference*<br/>
Fifth Edition

Order the <a href="https://gum.co/textadept_ebook" target="_blank">e-book</a> --
$15 USD<br/>
Order the <a href="https://gum.co/qr_bundle" target="_blank">e-book bundle</a>
with [Lua Quick Reference][] -- $27 USD<br/>
Order the print book via Amazon [US][], [CA][], [UK][], [DE][], [FR][], [IT][],
[ES][], [JP][] -- ~$25 USD

Published: Dec 2020 <span style="color: #ef373a;">[New!]</span><br/>
ISBN: 978-0-9912379-6-8<br/>
Pages: 179

[Excerpt][]

Textadept is a fast, minimalist, and remarkably extensible cross-platform text
editor for programmers. This quick reference contains a wealth of knowledge on
how to script and configure Textadept using the Lua programming language. It
groups the editor's rich API into a series of tasks in a convenient and
easy-to-use manner.

This book covers how to:

* Leverage Textadept's important files and folders
* Adeptly navigate and manipulate text
* Mark lines and text visually
* Show interactive lists and call tips
* Prompt for user input in various ways
* Spawn asynchronous, interactive child processes
* Configure colors, themes, and other settings
* Define lexers for highlighting source code
* And much more

It serves as the perfect complement to Textadept's comprehensive Manual and
exhaustive API documentation.

[Lua Quick Reference]: https://orbitalquark.github.io/lua-quick-reference
[US]: https://www.amazon.com/dp/099123796X/
[CA]: https://www.amazon.ca/dp/099123796X/
[UK]: https://www.amazon.co.uk/dp/099123796X/
[DE]: https://www.amazon.de/dp/099123796X/
[FR]: https://www.amazon.fr/dp/099123796X/
[IT]: https://www.amazon.it/dp/099123796X/
[ES]: https://www.amazon.es/dp/099123796X/
[JP]: https://www.amazon.co.jp/dp/099123796X/
[Excerpt]: https://github.com/orbitalquark/textadept/blob/default/docs/quickref_excerpt.pdf
